/**
**************************************************************************
* @file interface_config.h
* @brief Конфигурация для модбаса
*************************************************************************/
#ifndef _MODBUS_CONFIG_H_
#define _MODBUS_CONFIG_H_
#include "stm32f1xx_hal.h"

// MODBUS PARAMS
#define MODBUS_DEVICE_ID 							1			///< девайс текущего устройства
#define MODBUS_TIMEOUT 						    2000 	///< максимальнйы тайтаут MB в тиках таймера

// STRING OBJECTS MODBUS
#define MODBUS_VENDOR_NAME            "NIO-12"
#define MODBUS_PRODUCT_CODE           ""
#define MODBUS_REVISION               "Ver. 1.0"
#define MODBUS_VENDOR_URL             ""
#define MODBUS_PRODUCT_NAME           ""
#define MODBUS_MODEL_NAME             "STM32F103"
#define MODBUS_USER_APPLICATION_NAME  ""

// PERIPH FUNCTIONS AND HANDLERS
#define RS_UART_Init                  MX_USART1_UART_Init 	//инициализация uart
#define RS_UART_DeInit                HAL_UART_MspDeInit	//деинициализация uart
#define RS_TIM_Init                   MX_TIM2_Init 			//инициализация таймера
#define RS_TIM_DeInit                 HAL_TIM_Base_MspDeInit//деинициализация таймера
#define rs_huart                      huart1 				//используемый uart
#define rs_htim                       htim2 				//используемый таймера


/**
  * @brief    Поменять комманды 0x03 и 0x04 местами (для LabView терминалки от двигателей)
  * @details  Терминалка от двигателей использует для чтения регистров комманду R_HOLD_REGS вместо R_IN_REGS
  *           Поэтому чтобы считывать Input Regs - надо поменять их местами.
  */
//#define MODBUS_SWITCH_COMMAND_R_IN_REGS_AND_R_HOLD_REGS

/////////////////////////////////////////////////////////////////////
/////////////////////////---CALC DEFINES---//////////////////////////


  
#endif //_MODBUS_CONFIG_H_